﻿@page "/tarea"
@page "/tarea/{idTareaEditar:int}"


@using BlazorCrud.Shared;
@using BlazorCrud.Client.Services;

@inject ITareaService tareaService;
@inject NavigationManager navegacion;

<h3>@titulo</h3>

<EditForm Model="tarea" OnValidSubmit="OnValidSubmit">
    <DataAnnotationsValidator></DataAnnotationsValidator>

    <div>
        <label class="form-label">Nombre</label>
        <InputText class="form-control" @bind-Value="tarea.Nombre"></InputText>
        <ValidationMessage For="@(() => tarea.Nombre)"></ValidationMessage>
    </div>
    <div>
        <label class="form-label">Estado</label>
        <InputText class="form-control" @bind-Value="tarea.Estado"></InputText>
        <ValidationMessage For="@(() => tarea.Estado)"></ValidationMessage>
    </div>
    <div class="mb-3">
        <label class="form-label">Fecha</label>
        <InputDate class="form-control" @bind-Value="tarea.Fecha"></InputDate>
        <ValidationMessage For="@(() => tarea.Fecha)"></ValidationMessage>
    </div>



    <button class="btn btn-primary" type="submit">
        @btnTexto
    </button>

    <a class="btn btn-warning" href="tareas">Volver</a>
</EditForm>


@code {
    [Parameter]
    public int idTareaEditar { get; set; } = 0;


    string titulo = string.Empty;
    string btnTexto = string.Empty;

    TareaDTO tarea = new TareaDTO();
    List<TareaDTO> listaTarea = new List<TareaDTO>();


    protected override async Task OnInitializedAsync()
    {
        if (idTareaEditar != 0)
        {
            tarea = await tareaService.Buscar(idTareaEditar);
            tarea.Fecha = DateTime.Today;
            btnTexto = "Actualizar tarea";
            titulo = "Editar tarea";
        }
        else
        {
            tarea.Fecha = DateTime.Today;
            btnTexto = "Guardar tarea";
            titulo = "Nueva tarea";
            tarea.Activa = true;
            tarea.MetaId = 1;

        }

        listaTarea = await tareaService.Lista();
    }

    private async Task OnValidSubmit()
    {
        int idDevuelto = 0;
        if (idTareaEditar == 0)
            idDevuelto = await tareaService.Guardar(tarea);
        else
            idDevuelto = await tareaService.Editar(tarea);


        if (idDevuelto != 0)
            navegacion.NavigateTo("/tareas");

    }


}
